VERSION 5.00
Begin VB.Form DirectSound 
   ClientHeight    =   2790
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7410
   ClipControls    =   0   'False
   BeginProperty Font 
      Name            =   "Courier New"
      Size            =   12
      Charset         =   204
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H00000000&
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   ScaleHeight     =   186
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   494
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton bStop 
      Caption         =   "Stop"
      Height          =   555
      Left            =   4620
      TabIndex        =   5
      Top             =   1920
      Width           =   1455
   End
   Begin VB.CommandButton bPlayLoop 
      Caption         =   "PlayLoop"
      Height          =   555
      Left            =   2940
      TabIndex        =   4
      Top             =   1920
      Width           =   1455
   End
   Begin VB.CommandButton bPlay 
      Caption         =   "Play"
      Height          =   555
      Left            =   1260
      TabIndex        =   3
      Top             =   1920
      Width           =   1455
   End
   Begin VB.HScrollBar hsPan 
      Height          =   315
      Left            =   1260
      Max             =   10000
      Min             =   -10000
      TabIndex        =   2
      Top             =   1320
      Width           =   4815
   End
   Begin VB.HScrollBar hsVol 
      Height          =   315
      Left            =   1260
      Max             =   0
      Min             =   -10000
      TabIndex        =   1
      Top             =   840
      Width           =   4815
   End
   Begin VB.HScrollBar hsFreq 
      Height          =   315
      Left            =   1260
      Max             =   32000
      Min             =   4096
      TabIndex        =   0
      Top             =   360
      Value           =   20050
      Width           =   4815
   End
End
Attribute VB_Name = "DirectSound"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Sub memcpy Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)

Dim DS As DirectSound8
Dim DSB As IDirectSoundBuffer8

Private Sub bPlay_Click()
  DSB.SetCurrentPosition 0
  DSB.Play 0, 0, 0
End Sub

Private Sub bPlayLoop_Click()
  DSB.SetCurrentPosition 0
  DSB.Play 0, 0, DSBPLAY_LOOPING
End Sub

Private Sub bStop_Click()
  DSB.Stop
End Sub

Private Sub hsFreq_Change()
  DSB.SetFrequency hsFreq.Value
End Sub

Private Sub hsPan_Change()
  DSB.SetPan hsPan.Value
End Sub

Private Sub hsVol_Change()
  DSB.SetVolume hsVol.Value
End Sub

Private Sub Form_Load()
  Const WAVE_FORMAT_PCM As Long = 1
  Dim Ar() As Byte
  Dim nf As Integer
  Dim Sz As Long
  Dim DSBD As DSBUFFERDESC
  Dim WF As WAVEFORMATEX
  Dim Ptr As Long

  Show
  DoEvents
  Set DS = New DirectSound8
  DS.Initialize ByVal 0
  If Not (DS Is Nothing) Then
    DS.SetCooperativeLevel hWnd, DSSCL_NORMAL

    nf = FreeFile
    Open "Media\River.wav" For Binary As #nf
    Get #nf, &H29, Sz
    ReDim Ar(Sz - 1)
    Get #nf, &H2D, Ar()
    Close #nf

    DSBD.dwSize = Len(DSBD)
    DSBD.dwBufferBytes = Sz
    DSBD.dwFlags = DSBCAPS_CTRLVOLUME Or DSBCAPS_CTRLPAN Or DSBCAPS_CTRLFREQUENCY
    DSBD.lpwfxFormat = VarPtr(WF)

    WF.wFormatTag = WAVE_FORMAT_PCM
    WF.nChannels = 2
    WF.nSamplesPerSec = 22050
    WF.nBlockAlign = 2
    WF.nAvgBytesPerSec = 44100
    WF.wBitsPerSample = 8

    DS.CreateSoundBuffer DSBD, DSB, ByVal 0

    DSB.Lock 0, Sz, Ptr, 0, 0, 0, 0
    memcpy ByVal Ptr, Ar(0), Sz
    DSB.Unlock Ptr, Sz, 0, 0
  End If
End Sub

Private Sub ClearAll()
  DSB.Stop
  Set DSB = Nothing
  Set DS = Nothing
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
  ClearAll
End Sub
